#define  _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>

int main(int argc, char **argv) {
    FILE *input;
    char *line = NULL;
    size_t line_buf_length = 0;

    if (argc == 1 || argv[1][0] == '-')
		input = stdin;
	else if ((input = fopen(argv[1], "r")) == NULL) {
		fprintf(stderr, "Cannot open file %s\n", argv[1]);
		return -1;
	}

    uint64_t calibration_value = 0;

    while (getline(&line, &line_buf_length, input) != -1) {
        int64_t current_calibration_value = -1;
        uint8_t last_digit = 0;

        for (size_t i = 0; i < line_buf_length-1; ++i)
            if (line[i]>>4 == 0x3) {
                if (current_calibration_value == -1)
                    current_calibration_value = (line[i]&0xf) * 10;
                last_digit = line[i]&0xf;
            }

        if (current_calibration_value != -1)
            calibration_value += current_calibration_value + last_digit;

        memset(line, 0, line_buf_length);
    }

    printf("%lu\n", calibration_value);

    return 0;
}